{#-#####################################################################
 # Main template for /etc/network/interfaces
  ###################################################################-#}
{#-=====================================================================
 # macro format_option
 #======================================================================
 # Formats and echoes a single ifupdown option within a stanza. If
 # either ``option_name`` or ``option_value`` is empty, this macro shall
 # not echo anything.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - option_name (str)
 #      The name of the option to format.
 #
 #  - option_value (str)
 #      The value of the option to format.
 #===================================================================-#}
{%- macro format_option(option_name, option_value) -%}
  {%- if option_name and option_value -%}
    {{ '\t' ~ option_name ~ ' ' ~ option_value ~ '\n' }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro format_stanza_footer
 #======================================================================
 # Formats and echoes the footer of an ifupdown stanza.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface definition describing the interface to
 #      which the stanza was dedicated.
 #===================================================================-#}
{%- macro format_stanza_footer(interface) -%}
  {%- if 'description' in interface and interface['description'] -%}
    {{ '#' ~ interface['description'] ~ '\n' }}
  {%- endif -%}
  {{ '\n' }}
{%- endmacro -%}

{#-=====================================================================
 # macro format_stanza_header
 #======================================================================
 # Formats and echoes the header line of an ifupdown stanza.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface_name (str)
 #      The name of the interface to which the stanza is dedicated.
 #
 #  - protocol (str(inet|inet6))
 #      The protocol targeted by the stanza, either 'inet' or 'inet6'.
 #      Default is 'inet'.
 #
 #  - method (str)
 #      The addressing method. Either 'dhcp', 'bootp', 'static',
 #      'manual' or 'loopback'. Default to 'manual'.
 #===================================================================-#}
{%- macro format_stanza_header(
      interface_name, protocol='inet', method='manual')
-%}
  {{ 'iface ' ~ interface_name ~ ' ' ~ protocol ~ ' ' ~ method ~ '\n' }}
{%- endmacro -%}

{#-=====================================================================
 # macro get_bond_mode
 #======================================================================
 # Return the value of the bond_mode ifupdown attribute from a bond
 # interface definition.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should echo the bond mode.
 #===================================================================-#}
{%- macro get_bond_mode(interface) -%}
  {%-   if interface['bond']['mode'] == 'broadcast' -%}
    {{ 'broadcast' }}
  {%- elif interface['bond']['mode'] == 'failover' -%}
    {{ 'active-backup' }}
  {%- elif interface['bond']['mode'] == 'hash' -%}
    {{ 'balance-xor' }}
  {%- elif interface['bond']['mode'] == 'lacp' -%}
    {{ '802.3ad' }}
  {%- elif interface['bond']['mode'] == 'roundrobin' -%}
    {{ 'balance-rr' }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro get_bond_xmit_hash_policy
 #======================================================================
 # Return the value of the bond_xmit_hash_policy ifupdown attribute
 # from a bond interface definition.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should echo the transmit hash
 #       policy.
 #----------------------------------------------------------------------
 # Mapping table
 #----------------------------------------------------------------------
 #  ['l2']              --> 'layer2'
 #  ['l2', 'l3']        --> 'layer2+3'
 #  ['l2', 'l3', 'l4']  --> 'layer3+4'
 #  ['l2', 'l4']        --> 'layer2'
 #  ['l3']              --> 'layer2+3'
 #  ['l3', 'l4']        --> 'layer3+4'
 #===================================================================-#}
{%- macro get_bond_xmit_hash_policy(interface) -%}
  {%- if 'hash_sources' in interface['bond'] -%}
    {%-   if 'l2' in interface['bond']['hash_sources'] -%}
      {%- set policy = 'layer2' -%}
      {%- if 'l3' in interface['bond']['hash_sources'] -%}
        {%- set policy = 'layer2+3' -%}
        {%- if 'l4' in interface['bond']['hash_sources'] -%}
          {%- set policy = 'layer3+4' -%}
        {%- endif -%}
      {%- endif -%}
    {%- elif 'l3' in interface['bond']['hash_sources'] -%}
      {%- set policy = 'layer2+3' -%}
      {%- if 'l4' in interface['bond']['hash_sources'] -%}
        {%- set policy = 'layer3+4' -%}
      {%- endif -%}
    {%- endif -%}
    {{ policy }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro get_interface_gateway_address
 #======================================================================
 # Return the IP address of the default gateway bound to the specified
 # interface, if any.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should try to echo a default
 #      gateway address.
 #
 #  - protocol (str, optional)
 #      Accepted values: ['inet4', 'inet6']
 #      The type of IP address to echo. 
 #===================================================================-#}
{%- macro get_interface_gateway_address(interface, protocol='inet4') -%}
  {%- set default_gateways = [] -%}
  {%- set default_gateway_addresses = [] -%}

  {#- Get default routes -#}
  {%-   if protocol == 'inet4' -%}
    {%- set default_routes = my_network_routes |
        selectattr('destination', 'equalto', '0.0.0.0/0') -%}
  {%- elif protocol == 'inet6' -%}
    {%- set default_routes = my_network_routes |
        selectattr('destination', 'equalto', '::0/0') -%}
  {%- endif -%}

  {#- Get gateways bound to the specified interface -#}
  {%- for default_route in default_routes -%}
    {%- set default_gateway =
      my_network_gateways
      | selectattr('uid', 'equalto', default_route['gateway'])
      | first
    -%}
    {%- if default_gateway['interface'] == interface['uid'] -%}
      {{ default_gateways.append(default_gateway) }}
    {%- endif -%}
  {%- endfor -%}

  {#- Filter default gateways by protocol type -#}
  {%- for gateway in default_gateways -%}
    {%- if protocol == 'inet4' -%}
      {%- if protocol in gateway['addresses']
         and gateway['addresses'][protocol] | ipv4('address')
      -%}
        {{
          default_gateway_addresses.append(
            gateway['addresses'][protocol])
        }}
      {%- endif -%}
    {%- elif protocol == 'inet6' -%}
      {%- if protocol in gateway['addresses']
         and gateway['addresses'][protocol] | ipv6('address')
      -%}
        {%- set address =
              gateway['addresses'][protocol] | ipv6('address') -%}
        {#- We need to add the gateway interface as a suffix to
         #  link-local IPv6 addresses! -#}
        {%- if address | ipv6('fe80/10') -%}
          {%- set gateway_interface =
                my_network_interfaces[gateway['interface']] -%}
          {%- set gateway_interface_name =
                get_interface_name(gateway_interface) -%}
          {%- set address = address ~ '%' ~ gateway_interface_name -%}
        {%- endif -%}
        
        {{ default_gateway_addresses.append(address) }}
      {%- endif -%}
    {%- endif -%}
  {%- endfor -%}

  {#- Return the address of the first default gateway found, if any -#}
  {%- if default_gateway_addresses -%}
    {{ default_gateway_addresses | first }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro get_interface_inet_addresses
 #======================================================================
 # Echoes a list of IP address definitions assigned to the specified
 # interface.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should echo a list of IP
 #      assigned address definitions.
 #
 #  - protocol (str, optional)
 #      Accepted values: ['inet4', 'inet6']
 #      The type of IP address to search for. Default is to return
 #      inet4 addresses.
 #===================================================================-#}
{%- macro get_interface_inet_addresses(interface, protocol='inet4') -%}
  {%- set inet_addresses = [] -%}

  {%- for inet_address in my_network_addresses -%}
    {%- if inet_address['interface'] == interface['uid'] -%}
      {%- if inet_address['protocol'] == protocol -%}
        {{ inet_addresses.append(inet_address) }}
      {%- endif -%}
    {%- endif -%}
  {%- endfor -%}

  {{ inet_addresses | to_json }}
{%- endmacro -%}

{#-=====================================================================
 # macro get_interface_name
 #======================================================================
 # Return the ifupdown name of the supplied interface definition.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should echo an ifupdown
 #      interface name.
 #===================================================================-#}
{%- macro get_interface_name(interface) -%}
  {#- Adapter interfaces -#}
  {%-   if interface['type'] == 'adapter' -%}
    {{ interface['adapter']['device'] }}

  {#- Bond interfaces -#}
  {%- elif interface['type'] == 'bond' -%}
    {%- if 'name' in interface -%}
      {{ interface['name'] }}
    {%- else -%}
      {{ 'bond' ~ interface['bond']['index'] }}
    {%- endif -%}

  {#- Bridge interfaces -#}
  {%- elif interface['type'] == 'bridge' -%}
    {%- if 'name' in interface -%}
      {{ interface['name'] }}
    {%- else -%}
      {{ 'br' ~ interface['bridge']['index'] }}
    {%- endif -%}

  {#- Vlan interfaces -#}
  {%- elif interface['type'] == 'vlan' -%}
    {%- if 'name' in interface -%}
      {{ interface['name'] }}
    {%- else -%}
      {#- Resolve the interface name of the parent interface -#}
      {%- set parent_interface_uid = interface['vlan']['parent'] -%}
      {%- set parent_interface = my_network_interfaces
        | selectattr('uid', 'equalto', parent_interface_uid)
        | first -%}
      {%- set parent_interface_name =
        get_interface_name(parent_interface) -%}
      {{ parent_interface_name ~ '.' ~ interface['vlan']['index'] }}
    {%- endif -%}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro get_interface_names_from_list
 #======================================================================
 # Return the ifupdown name of each interface supplied in a list of
 # interface definitions. The final list is echoed back as a JSON
 # string.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interfaces (fr.pep06.schemas.network.interface[])
 #      A list of interface definitions. The macro will call the
 #      get_interface_name() macro for each entry, and return a str[]
 #      of the same length with ifupdown interface names.
 #===================================================================-#}
{%- macro get_interface_names_from_list(interface_uids) -%}
  {%- set interface_names = [] -%}
  {%- for interface_uid in interface_uids -%}
    {%- set interface = my_network_interfaces
      | selectattr('uid', 'equalto', interface_uid) | first -%}
    {{ interface_names.append(get_interface_name(interface)) }}
  {%- endfor -%}
  {{ interface_names | to_json }}
{%- endmacro -%}

{#-=====================================================================
 # macro render_allow_stanzas
 #======================================================================
 # Generates and echoes ifupdown 'allow-*' stanzas for the supplied
 # interface.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the auto stanzas
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #      While the syntax of 'allow-*' stanzas is the same syntax in all
 #      ifupdown versions, this parameter must be provided anyway to
 #      maintain consistency.
 #===================================================================-#}
{%- macro render_allow_stanzas(interface, ifupdown_version=1) -%}
  {#- Get interface name -#}
  {%- set interface_name = get_interface_name(interface) -%}

  {#- Render autostart stanzas -#}
  {%- if 'autostart' in interface -%}
    {#- Automatic start on boot -#}
    {%- if 'on_boot' in interface['autostart']
        and interface['autostart']['on_boot']
    -%}
      {{ 'auto ' ~ interface_name ~ '\n' }}
    {%- endif -%}

    {#- Automatic start on hotplug -#}
    {%- if 'on_plug' in interface['autostart']
        and interface['autostart']['on_plug']
    -%}
      {{ 'allow-hotplug ' ~ interface_name ~ '\n' }}
    {%- endif -%}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro render_bond_options
 #======================================================================
 # Echoes ifupdown options for bond interfaces.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the options.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_bond_options(interface, ifupdown_version=1) -%}
  {#- Bond slaves -#}
  {%- set option_name = 'slaves' -%}
  {%- if ifupdown_version == 2 -%}
    {%- set option_name = 'bond-slaves' -%}
  {%- endif -%}
  {%- set option_value =
    get_interface_names_from_list(interface['bond']['members'])
    | from_json
    | join(' ')
  -%}
  {{ format_option(option_name, option_value) }}

  {#- Bond slave monitoring. Default to miimon. -#}
  {%- set option_name = 'bond_miimon' -%}
  {%- if ifupdown_version == 2 -%}
    {%- set option_name = 'bond-miimon' -%}
  {%- endif -%}
  {{ format_option(option_name, '100') }}

  {#- Bond mode -#}
  {%- set option_name = 'bond_mode' -%}
  {%- if ifupdown_version == 2 -%}
    {%- set option_name = 'bond-mode' -%}
  {%- endif -%}
  {%- set option_value = get_bond_mode(interface) -%}
  {{ format_option(option_name, option_value) }}

  {#- Bond transmit hash policy -#}
  {%- set option_name = 'bond_xmit_hash_policy' -%}
  {%- if ifupdown_version == 2 -%}
    {%- set option_name = 'bond-xmit-hash-policy' -%}
  {%- endif -%}
  {%- set option_value = get_bond_xmit_hash_policy(interface) -%}
  {{ format_option(option_name, option_value) }}
{%- endmacro -%}

{#-=====================================================================
 # macro render_bridge_options
 #======================================================================
 # Echoes ifupdown options for bridge interfaces.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the options.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_bridge_options(interface, ifupdown_version=1) -%}
  {#--------------------------------------------------------------------
   # Bridge members
   #------------------------------------------------------------------#}
  {%- set option_name = 'bridge_ports' -%}
  {%- if ifupdown_version == 2 -%}
    {%- set option_name = 'bridge-ports' -%}
  {%- endif -%}
  {%- set option_value =
    (get_interface_names_from_list(interface['bridge']['members'])
    | from_json
    | join(" ")) or 'none'
  -%}
  {{ format_option(option_name, option_value) }}

  {#--------------------------------------------------------------------
   # STP options
   #------------------------------------------------------------------#}
  {#- Enable / disable STP -#}
  {%- set option_name = 'bridge_stp' -%}
  {%- if ifupdown_version == 2 -%}
    {%- set option_name = 'bridge-stp' -%}
  {%- endif -%}
  {%- if  'bridge' in interface
      and 'stp' in interface['bridge']
      and 'enabled' in interface['bridge']['stp']
      and interface['bridge']['stp']['enabled']
  -%}
    {{ format_option(option_name, 'on') }}
  {%- else -%}
    {{ format_option(option_name, 'off') }}
  {%- endif -%}

  {#- Forwarding delay -#}
  {%- set option_name = 'bridge_fd' -%}
  {%- if ifupdown_version == 2 -%}
    {%- set option_name = 'bridge-fd' -%}
  {%- endif -%}
  {%- if  'bridge' in interface
      and 'stp' in interface['bridge']
      and 'delay' in interface['bridge']['stp']
  -%}
    {{ format_option(
      option_name,
      interface['bridge']['stp']['delay']) }}
  {%- else -%}
    {{ format_option(option_name, '0') }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # vLAN options
   #------------------------------------------------------------------#}
  {%- if  'bridge' in interface
      and 'vlan' in interface['bridge']
      and 'enabled' in interface['bridge']['vlan']
  -%}
    {#- If vLANs are explicitly enabled -#}
    {%- if interface['bridge']['vlan']['enabled'] -%}
      {#- bridge_vlan_aware -#}
      {%- set option_name = 'bridge_vlan_aware' -%}
      {%- if ifupdown_version == 2 -%}
        {%- set option_name = 'bridge-vlan-aware' -%}
      {%- endif -%}
      {%- set option_value = 'yes' -%}
      {{ format_option(option_name, option_value) }}

      {#- bridge-vids (ifupdown2 only) -#}
      {%- if ifupdown_version == 2 -%}
        {%- set option_name = 'bridge-vids' -%}
        {%- set option_value = '2-4094' -%}
        {%- if 'range' in interface['bridge']['vlan'] -%}
          {%- set option_value = interface['bridge']['vlan']['range']-%}
        {%- endif -%}
        {{ format_option(option_name, option_value) }}
      {%- endif -%}
    
    {#- If vLANs are explicitly disabled -#}
    {%- else -%}
      {#- bridge_vlan_aware -#}
      {%- set option_name = 'bridge_vlan_aware' -%}
      {%- if ifupdown_version == 2 -%}
        {%- set option_name = 'bridge-vlan-aware' -%}
      {%- endif -%}
      {%- set option_value = 'no' -%}
      {{ format_option(option_name, option_value) }}
    {%- endif -%}
  {%- endif -%}

{%- endmacro -%}

{#-=====================================================================
 # macro render_common_options
 #======================================================================
 # Generates and echoes ifupdown options relative to virtual interfaces,
 # such as bond, bridge and vlan options. While the configuration of a
 # single network interface may be split into several stanzas, these
 # options must only appear once. As a consequence, the logic needed to
 # generate these common options was enclosed in this dedicated macro,
 # which is called once for each interface, in the context of the main
 # stanza.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render common options.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_common_options(interface, ifupdown_version=1) -%}
  {#- Disable IPv6, if needed -#}
  {{ render_inet6_disable_option(interface, ifupdown_version) }}

  {#- Ethernet options -#}
  {{ render_ethernet_options(interface, ifupdown_version) }}

  {#- Bond interface options -#}
  {%- if interface['type'] == 'bond' -%}
    {{ render_bond_options(interface, ifupdown_version) }}
  {%- endif -%}

  {#- Bridge interface options -#}
  {%- if interface['type'] == 'bridge' -%}
    {{ render_bridge_options(interface, ifupdown_version) }}
  {%- endif -%}

  {#- vLAN interface options -#}
  {%- if interface['type'] == 'vlan' -%}
    {{ render_vlan_options(interface, ifupdown_version) }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro render_ethernet_options
 #======================================================================
 # Echoes ifupdown options relative to the Ethernet layer.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the options.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_ethernet_options(interface, ifupdown_version=1) -%}
  {%- if 'ethernet' in interface -%}

    {#- Hardware address -#}
    {%- if 'address' in interface['ethernet'] -%}
      {%- set option_name = 'hwaddress' -%}
      {%- set option_value = interface['ethernet']['address'] -%}
      {{ format_option(option_name, option_value) }}
    {%- endif -%}

    {#- MTU -#}
    {%- if 'mtu' in interface['ethernet'] -%}
      {%- set option_name = 'mtu' -%}
      {%- set option_value = interface['ethernet']['mtu'] -%}
      {{ format_option(option_name, option_value) }}
    {%- endif -%}

  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro render_fallback_stanza
 #======================================================================
 # Generates and echoes a last-resort ifupdown stanza when both IPv4
 # and IPv6 are disabled on the same interface. The purpose of this
 # fallback stanza is to ensure common options are defined.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the stanzas.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_fallback_stanza(interface, ifupdown_version=1) -%}
  {#--------------------------------------------------------------------
   # Preliminary tasks
   #------------------------------------------------------------------#}
  {#- Resolve interface name -#}
  {%- set interface_name = get_interface_name(interface) -%}

  {#--------------------------------------------------------------------
   # Render the fallback manual stanza
   #------------------------------------------------------------------#}
  {{ format_stanza_header(interface_name, 'inet', 'manual') }}

  {#- Render common options -#}
  {{ render_common_options(interface, ifupdown_version) }}
  {%- set common_options_rendered = true -%}

  {{ format_stanza_footer(interface) }}
{%- endmacro -%}

{#-=====================================================================
 # macro render_inet4_stanzas
 #======================================================================
 # Generates and echoes as many ifupdown stanzas as needed to describe
 # the IPv4 network configuration of the supplied interface.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the stanzas.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_inet4_stanzas(interface, ifupdown_version=1) -%}
  {#--------------------------------------------------------------------
   # Preliminary tasks
   #------------------------------------------------------------------#}
  {#- This flag indicates whether common options were generated -#}
  {%- set common_options_rendered = false -%}

  {#- This flag indicates how many stanzas were generated -#}
  {%- set stanza_count = 0 -%}

  {#- Resolve interface name -#}
  {%- set interface_name = get_interface_name(interface) -%}

  {#--------------------------------------------------------------------
   # Render DHCP stanza
   #------------------------------------------------------------------#}
  {%- if  'inet4' in interface
      and 'dhcp' in interface['inet4']
      and 'enabled' in interface['inet4']['dhcp']
      and interface['inet4']['dhcp']['enabled']
  -%}
    {{ format_stanza_header(interface_name, 'inet', 'dhcp') }}

    {#- Render common options if needed -#}
    {%- if not common_options_rendered -%}
      {{ render_common_options(interface, ifupdown_version) }}
      {%- set common_options_rendered = true -%}
    {%- endif -%}

    {{ format_stanza_footer(interface) }}
    {%- set stanza_count = stanza_count + 1 -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Render static addressing stanzas
   #------------------------------------------------------------------#}
  {%- if  'inet4' in interface
      and 'static' in interface['inet4']
      and 'enabled' in interface['inet4']['static']
      and interface['inet4']['static']['enabled']
  -%}
    {#- Get the list of all IP addresses assigned to this interface -#}
    {%- set ip_addresses =
      get_interface_inet_addresses(interface, 'inet4') | from_json -%}

    {#- ifupdown1: Render one stanza per static IP address -#}
    {%-   if ifupdown_version == 1 -%}
      {%- for ip_address in ip_addresses -%}
      
        {#- Some tasks must only be performed with the main IP address -#}
        {%- if loop.index0 == 0 -%}
          {%- set gateway_address =
            get_interface_gateway_address(interface, 'inet4') -%}
          {%- set stanza_interface_name = interface_name -%}
        {#- Aliases have no gateway and an indexed interface name -#}
        {%- else -%}
          {%- set gateway_address = false -%}
          {%- set stanza_interface_name =
            interface_name ~ ':' ~ loop.index0 - 1 -%}
        {%- endif -%}

        {#- Render stanza header -#}
        {{ format_stanza_header(stanza_interface_name, 'inet', 'static')}}

        {#- Render IP address, netmask and gateway -#}
        {{
          format_option(
            'address',
            ip_address['address'] | ipv4('address')) ~
          format_option(
            'netmask',
            ip_address['address'] | ipv4('netmask'))
        }}
        {%- if gateway_address -%}
          {{ format_option('gateway', gateway_address) }}
        {%- endif -%}

        {#- Render common options if needed -#}
        {%- if not common_options_rendered -%}
          {{ render_common_options(interface, ifupdown_version) }}
          {%- set common_options_rendered = true -%}
        {%- endif -%}

        {#- Render stanza footer -#}
        {{ format_stanza_footer(interface) }}
      {%- endfor -%}
      {%- set stanza_count = stanza_count + ip_addresses | length -%}

    {#- ifupdown2: Render all IP addresses in a single stanza -#}
    {%- elif ifupdown_version == 2 -%}

      {#- Render stanza header -#}
      {{ format_stanza_header(interface_name, 'inet', 'static') }}

      {#- Render all IP addresses -#}
      {%- for ip_address in ip_addresses -%}
        {{ format_option(
            'address',
            ip_address['address'] | ipv4('host/prefix')) }}
      {%- endfor -%}

      {#- Render IP gateway -#}
      {%- set gateway_address =
        get_interface_gateway_address(interface, 'inet4') -%}
      {%- if gateway_address -%}
        {{ format_option('gateway', gateway_address) }}
      {%- endif -%}

      {#- Render common options if needed -#}
      {%- if not common_options_rendered -%}
        {{ render_common_options(interface, ifupdown_version) }}
        {%- set common_options_rendered = true -%}
      {%- endif -%}

      {#- Render stanza footer -#}
      {{ format_stanza_footer(interface) }}

      {#- Increase stanza count -#}
      {%- set stanza_count = stanza_count + 1 -%}
    {%- endif -%}
  
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Render fallback manual stanza
   #------------------------------------------------------------------#}
  {%- if stanza_count == 0 -%}
  {#- Render common options if needed -#}
    {{ format_stanza_header(interface_name, 'inet', 'manual') }}

    {#- Render common options if needed -#}
    {%- if not common_options_rendered -%}
      {{ render_common_options(interface, ifupdown_version) }}
      {%- set common_options_rendered = true -%}
    {%- endif -%}

    {{ format_stanza_footer(interface) }}
    {%- set stanza_count = stanza_count + 1 -%}
  {%- endif -%}

{%- endmacro -%}

{#-=====================================================================
 # macro render_inet6_disable_option
 #======================================================================
 # Generates and echoes a special option to disable IPv6 on the
 # specified interface, if needed. If IPv6 is enabled, this macro
 # echoes nothing.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the stanzas.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_inet6_disable_option(interface, ifupdown_version=1) -%}
  {#- Resolve interface name -#}
  {%- set interface_name = get_interface_name(interface) -%}

  {#- Check whether IPv6 is enabled -#}
  {%- if 'inet6' in interface and 'enabled' in interface['inet6'] -%}
    {%- set inet6_is_enabled = interface['inet6']['enabled'] -%}
  {%- else -%}
    {%- set inet6_is_enabled = false -%}
  {%- endif -%}

  {#- Disable IPv6 -#}
  {%- if not inet6_is_enabled -%}
    {{
      '\t' ~ 'post-up' ~ '  ' ~
      'echo 1 > /proc/sys/net/ipv6/conf/' ~
      interface_name ~ '/disable_ipv6' ~ '\n'
    }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro render_inet6_stanzas
 #======================================================================
 # Generates and echoes as many ifupdown stanzas as needed to describe
 # the IPv6 network configuration of the supplied interface.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the stanzas.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #
 #  - render_common_options (bool)
 #      Whether the macro should render common options for virtual
 #      interfaces. Such options are usually rendered within the context
 #      of an inet stanza. This parameter is only set to true when IPv4
 #      is totally disabled on the supplied interface: in such a context
 #      common options must be rendered within an inet6 stanza.
 #===================================================================-#}
{%- macro render_inet6_stanzas(
      interface, ifupdown_version=1, render_common_options=false)
-%}
  {#--------------------------------------------------------------------
   # Preliminary tasks
   #------------------------------------------------------------------#}
  {#- This flag indicates whether common options were generated -#}
  {%- set common_options_rendered = not render_common_options -%}

  {#- This flag indicates how many stanzas were generated -#}
  {%- set stanza_count = 0 -%}

  {#- Resolve interface name -#}
  {%- set interface_name = get_interface_name(interface) -%}

  {#--------------------------------------------------------------------
   # Render auto stanza
   #------------------------------------------------------------------#}
  {%- if  'inet6' in interface
      and 'autoconf' in interface['inet6']
      and 'enabled' in interface['inet6']['autoconf']
      and interface['inet6']['autoconf']['enabled']
  -%}
    {{ format_stanza_header(interface_name, 'inet6', 'auto') }}

    {#- Render common options if needed -#}
    {%- if not common_options_rendered -%}
      {{ render_common_options(interface, ifupdown_version) }}
      {%- set common_options_rendered = true -%}
    {%- endif -%}

    {{ format_stanza_footer(interface) }}
    {%- set stanza_count = stanza_count + 1 -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Render static addressing stanzas
   #------------------------------------------------------------------#}
  {%- if  'inet6' in interface
      and 'static' in interface['inet6']
      and 'enabled' in interface['inet6']['static']
      and interface['inet6']['static']['enabled']
  -%}
    {#- Get the list of all IP addresses assigned to this interface -#}
    {%- set ip_addresses =
      get_interface_inet_addresses(interface, 'inet6') | from_json -%}

    {#- ifupdown1: Render one stanza per static IP address -#}
    {%-   if ifupdown_version == 1 -%}
      {%- for ip_address in ip_addresses -%}
      
        {#- Some tasks must only be performed with the main IP address -#}
        {%- if loop.index0 == 0 -%}
          {%- set gateway_address =
            get_interface_gateway_address(interface, 'inet6') -%}
          {%- set stanza_interface_name = interface_name -%}
        {#- Aliases have no gateway and an indexed interface name -#}
        {%- else -%}
          {%- set gateway_address = false -%}
          {%- set stanza_interface_name =
            interface_name ~ ':' ~ loop.index0 - 1 -%}
        {%- endif -%}

        {#- Render stanza header -#}
        {{
          format_stanza_header(
            stanza_interface_name, 'inet6', 'static')
        }}

        {#- Render IP address, netmask and gateway -#}
        {{
          format_option(
            'address',
            ip_address['address'] | ipv6('address')) ~
          format_option(
            'netmask',
            ip_address['address'] | ipv6('prefix'))
        }}
        {%- if gateway_address -%}
          {{ format_option('gateway', gateway_address) }}
        {%- endif -%}

        {#- Render common options if needed -#}
        {%- if not common_options_rendered -%}
          {{ render_common_options(interface, ifupdown_version) }}
          {%- set common_options_rendered = true -%}
        {%- endif -%}

        {#- Render stanza footer -#}
        {{ format_stanza_footer(interface) }}
      {%- endfor -%}
      {%- set stanza_count = stanza_count + ip_addresses | length -%}

    {#- ifupdown2: Render all IP addresses in a single stanza -#}
    {%- elif ifupdown_version == 2 -%}

      {#- Render stanza header -#}
      {{ format_stanza_header(interface_name, 'inet6', 'static') }}

      {#- Render all IP addresses -#}
      {%- for ip_address in ip_addresses -%}
        {{ format_option(
            'address',
            ip_address['address'] | ipv6('host/prefix')) }}
      {%- endfor -%}

      {#- Render IP gateway -#}
      {%- set gateway_address =
        get_interface_gateway_address(interface, 'inet6') -%}
      {%- if gateway_address -%}
        {{ format_option('gateway', gateway_address) }}
      {%- endif -%}

      {#- Render common options if needed -#}
      {%- if not common_options_rendered -%}
        {{ render_common_options(interface, ifupdown_version) }}
        {%- set common_options_rendered = true -%}
      {%- endif -%}

      {#- Render stanza footer -#}
      {{ format_stanza_footer(interface) }}

      {#- Increase stanza count -#}
      {%- set stanza_count = stanza_count + 1 -%}
    {%- endif -%}
  
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Render fallback manual stanza
   #------------------------------------------------------------------#}
  {%- if stanza_count == 0 -%}
  {#- Render common options if needed -#}
    {{ format_stanza_header(interface_name, 'inet6', 'manual') }}

    {#- Render common options if needed -#}
    {%- if not common_options_rendered -%}
      {{ render_common_options(interface, ifupdown_version) }}
      {%- set common_options_rendered = true -%}
    {%- endif -%}

    {{ format_stanza_footer(interface) }}
    {%- set stanza_count = stanza_count + 1 -%}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro render_vlan_options
 #======================================================================
 # Echoes ifupdown options for vlan interfaces.
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should render the options.
 #
 #  - ifupdown_version (int)
 #      The major version of the ifupdown framework to use. Supported
 #      value are:
 #        - 1 (default) to use the classic ifupdown syntax
 #        - 2 to use the ifupdown2 syntax
 #===================================================================-#}
{%- macro render_vlan_options(interface, ifupdown_version=1) -%}
    {#- vLAN raw device
        Using a custom interface name requires specifying the parent
        device or the vLAN interface -#}
    {%- if 'name' in interface and interface['name'] -%}
      {%- set option_name = 'vlan_raw_device' -%}
      {%- if ifupdown_version == 2 -%}
        {%- set option_name = 'vlan-raw-device' -%}
      {%- endif -%}
      {%- set option_value =
        get_interface_name(interface['vlan']['parent']) -%}
      {{ format_option(option_name, option_value) }}
    {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # Configuration options
 # ---------------------------------------------------------------------
 # Configuration settings
 #===================================================================-#}

{#- Set the ifupdown version to use -#}
{%- set ifupdown_version = role_platform_options['ifupdown_version'] -%}

{#-=====================================================================
 # Static content
 # ---------------------------------------------------------------------
 # These lines will always be rendered as-is
 #===================================================================-#}

{{ '#' ~ ansible_managed }}

{{ 'auto lo' }}
{{ 'iface lo inet loopback' ~ '\n\n' }}

{#-=====================================================================
 # Dynamic content
 # ---------------------------------------------------------------------
 # This section is dynamically generated
 #===================================================================-#}
{%- for interface in my_network_interfaces -%}

  {#--------------------------------------------------------------------
   # Preliminary tasks
   #------------------------------------------------------------------#}

  {#- Check whether IPv4 is enabled -#}
  {%- if 'inet4' in interface and 'enabled' in interface['inet4'] -%}
    {%- set inet4_is_enabled = interface['inet4']['enabled'] -%}
  {%- else -%}
    {%- set inet4_is_enabled = false -%}
  {%- endif -%}

  {#- Check whether IPv6 is enabled -#}
  {%- if 'inet6' in interface and 'enabled' in interface['inet6'] -%}
    {%- set inet6_is_enabled = interface['inet6']['enabled'] -%}
  {%- else -%}
    {%- set inet6_is_enabled = false -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Interface configuration generation
   #------------------------------------------------------------------#}

  {#- Render 'allow-*' stanzas -#}
  {{ render_allow_stanzas(interface, ifupdown_version) }}

  {#- Render IPv4 stanzas -#}
  {%- if inet4_is_enabled -%}
    {{ render_inet4_stanzas(interface, ifupdown_version) }}
  {%- endif -%}

  {#- Render IPv6 stanzas -#}
  {%- if inet6_is_enabled -%}
    {%- if inet4_is_enabled -%}
      {{ render_inet6_stanzas(interface, ifupdown_version, false) }}
    {%- else -%}
      {{ render_inet6_stanzas(interface, ifupdown_version, true) }}
    {%- endif -%}
  {%- endif -%}

  {#- Render fallback stanza -#}
  {%- if not inet4_is_enabled and not inet6_is_enabled -%}
    {{ render_fallback_stanza(interface, ifupdown_version) }}
  {%- endif -%}

{%- endfor -%}
{#- End of interface enumeration -#}
